#include <stdio.h>
#include <string.h>
#include <mach/machine/mach_i386.h>

#define set_gs(val) \
	asm volatile ("movw %w0, %%gs" : : "q" (val))

#define get_val(offset) ({ \
	int val; \
	asm ("movl %%gs:(%1),%0":"=r"(val):"r"(offset)); \
	val; \
})

#define set_val(offset, val) \
	asm ("movl %0,%%gs:(%1)"::"r"(val), "r"(offset)); \


/*
 * Real segment descriptor.
 */
struct real_descriptor {
    unsigned int    limit_low:16,   /* limit 0..15 */
            base_low:16,    /* base  0..15 */
            base_med:8, /* base  16..23 */
            access:8,   /* access byte */
            limit_high:4,   /* limit 16..19 */
            granularity:4,  /* granularity */
            base_high:8;    /* base 24..31 */
};

int main (char *argv, int argc) 
{

int ary[4] = { 1, 2, 3, 4 };
mach_port_t thread1 = mach_thread_self();
int size = -1;
int addr = (int)&ary[3];
int foo = -1, bar = -1;
kern_return_t rt;

union { struct real_descriptor rdesc; descriptor_t desc; } foodesc = { .rdesc =
{
.limit_low = (size>>12) & 0xffff, 
.base_low = addr & 0xffff, 
.base_med = (addr >> 16) & 0xff, 
.access = 0x60|0x12|0x80,
.limit_high = (size >> 28) & 0xf, 
.granularity = 0x4|0x8, 
.base_high = (addr >> 24) & 0xff
}
};

rt = i386_set_gdt (thread1, &foo, foodesc.desc);
printf("Return from set_gdt() is: %d, foo is %x\r\n", rt, foo);
set_gs(foo);
printf("val %d\n",get_val(0));
printf("val %d\n",get_val(-4));
printf("val %d\n",get_val(-8));
printf("val %d\n",get_val(-12));
set_val(0,1);
printf("val now %d\n",ary[3]);

rt = i386_set_gdt (thread1, &bar, foodesc.desc);
printf("Return from set_gdt() is: %d, bar is %x\r\n", rt, bar);
set_gs(bar);
printf("val %d\n",get_val(0));

bar = -1;
rt = i386_set_gdt (thread1, &bar, foodesc.desc);
printf("Return from set_gdt() is: %d, bar is %x\r\n", rt, bar);
return 0;
}
