#include <stdio.h>
#include <string.h>
#include <mach/machine/mach_i386.h>

/*
 * Real segment descriptor.
 */
struct real_descriptor {
    unsigned int    limit_low:16,   /* limit 0..15 */
            base_low:16,    /* base  0..15 */
            base_med:8, /* base  16..23 */
            access:8,   /* access byte */
            limit_high:4,   /* limit 16..19 */
            granularity:4,  /* granularity */
            base_high:8;    /* base 24..31 */
};

int main (char *argv, int argc) 
{

int ary[4] = { 1, 2, 3, 4 };
mach_port_t thread1 = mach_thread_self();
int size = sizeof(ary);
int addr = (int)&ary[3];
int foo = -1;
kern_return_t rt;

union { struct real_descriptor rdesc; descriptor_t desc; } foodesc = { .rdesc =
{
.limit_low = (size>>12) & 0xffff, 
.base_low = addr & 0xffff, 
.base_med = (addr >> 16) & 0xff, 
.access = 0x60|0x12|0x80, 
.limit_high = (size >> 28) & 0xf, 
.granularity = 0x4|0x8, 
.base_high = (addr >> 24) & 0xff
}
};

printf("%p\n",thread1);
rt = i386_get_gdt (thread1, (9<<3)|3, &foodesc.desc);
printf("Return from get_gdt() is: %d\r\n", rt);
printf("desc %lx %lx\n",foodesc.desc.low_word, foodesc.desc.high_word);

return 0;
}
